
//
// Verlihub Python Plugin v.1.1
//
// Created in 2007 by Frog, frg@otaku-anime.net
// Code template based on Lua plugin, (c) 2004 by Janos Horvath, bourne@freemail.hu
// Code licensed under the GNU Library General Public License
//

#ifndef CPIPYTHON_H
#define CPIPYTHON_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "cpythoninterpreter.h"
#include "cconsole.h"
#include <verlihub/cconndc.h>
#include <verlihub/cvhplugin.h>
#include <verlihub/cserverdc.h>
#include <verlihub/cuser.h>
#include <verlihub/script_api.h>
#include <iostream>
#include <vector>
#include <dlfcn.h>

#define PYTHON_PI_IDENTIFIER "python"
#define PYTHON_PI_VERSION "1.1"

using std::vector;
using namespace nScripts;
using namespace nDirectConnect;
using namespace nDirectConnect::nPlugin;


class cpiPython : public cVHPlugin
{
public:
	cpiPython();
	virtual ~cpiPython();
	bool RegisterAll();
	virtual void OnLoad(cServerDC *);
	virtual bool OnNewConn(cConnDC *);
	virtual bool OnCloseConn(cConnDC *);
	virtual bool OnParsedMsgChat(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgPM(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgSearch(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgSR(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgMyINFO(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgValidateNick(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgAny(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgSupport(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgMyPass(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgConnectToMe(cConnDC *, cMessageDC *);
	virtual bool OnParsedMsgRevConnectToMe(cConnDC *, cMessageDC *);
	virtual bool OnUnknownMsg(cConnDC *, cMessageDC *);
	virtual bool OnOperatorCommand(cConnDC *, std::string *);
	virtual bool OnOperatorKicks(cUser *, cUser *, std::string *);
	virtual bool OnOperatorDrops(cUser *, cUser *);
	virtual bool OnValidateTag(cConnDC *, cDCTag *);
	virtual bool OnUserCommand(cConnDC *, std::string *);
	virtual bool OnUserLogin(cUser *);
	virtual bool OnUserLogout(cUser *);
	virtual bool OnTimer();
	virtual bool OnNewReg(cRegUserInfo *);
	virtual bool OnNewBan(cBan *);
	
	bool AutoLoad();
	const char *GetName (const char *path);
	int SplitMyINFO(const char *msg, const char **nick, const char **desc, const char **tag, const char **speed, const char **mail, const char **size);
	const char *GetConf(const char *conf, const char *var);
	bool SetConf(const char *conf, const char *var, const char *val);
	w_Targs* SQL (int id, w_Targs* args);
	void LogLevel(int);
	bool IsNumber( const char* s );
	int char2int( char c );
	cPythonInterpreter *GetInterpreter(int id);
	bool CallAll(int func, w_Targs* args);
	int Size() { return mPython.size(); }
	void Empty()
	{
		tvPythonInterpreter::iterator it;
		for(it = mPython.begin(); it != mPython.end(); ++it)
		{
			if(*it != NULL) delete *it;
			*it = NULL;
		}
		mPython.clear();
	}
	int AddData(cPythonInterpreter *ip)
	{
		mPython.push_back(ip); 
		return 0;
	}
	cPythonInterpreter * operator[](int i)
	{
		if(i < 0 || i > Size()) return NULL;
		return mPython[i];
	}
	
	cQuery *mQuery;
	cConsole mConsole;
	typedef vector<cPythonInterpreter *> tvPythonInterpreter;
	tvPythonInterpreter mPython;
	string mScriptDir;
	bool online;
	
	static void*        lib_handle;
	static w_TBegin     lib_begin;
	static w_TEnd       lib_end;
	static w_TReserveID lib_reserveid;
	static w_TLoad      lib_load;
	static w_TUnload    lib_unload;
	static w_THasHook   lib_hashook;
	static w_TCallHook  lib_callhook;
	static w_THookName  lib_hookname;
	static w_Tpack      lib_pack;
	static w_Tunpack    lib_unpack;
	static w_TLogLevel  lib_loglevel;
	static w_Tpackprint lib_packprint;

	static string botname;
	static string opchatname;
	static int log_level;
	static cServerDC *server;
	static cpiPython *me;
};

extern "C" w_Targs* _SendDataToUser    (int id, w_Targs* args);  //(char *data, char *nick);
extern "C" w_Targs* _SendDataToAll     (int id, w_Targs* args);  //(char *data, long min_class, long max_class);
extern "C" w_Targs* _SendPMToAll       (int id, w_Targs* args);  //(char *data, char *from, long min_class, long max_class);
extern "C" w_Targs* _mc                (int id, w_Targs* args);  //(char *data);
extern "C" w_Targs* _usermc            (int id, w_Targs* args);  //(char *data, char *nick);
extern "C" w_Targs* _classmc           (int id, w_Targs* args);  //(char *data, long min_class, long max_class);
extern "C" w_Targs* _pm                (int id, w_Targs* args);  //(char *data, char *nick);
extern "C" w_Targs* _CloseConnection   (int id, w_Targs* args);  //(char *nick);
extern "C" w_Targs* _GetMyINFO         (int id, w_Targs* args);  //(char *nick);
extern "C" w_Targs* _SetMyINFO         (int id, w_Targs* args);  //(char *nick, char *desc, char *speed, char *email, char *size);
extern "C" w_Targs* _GetUserClass      (int id, w_Targs* args);  //(char *nick);
extern "C" w_Targs* _GetNickList       (int id, w_Targs* args);  //();
extern "C" w_Targs* _GetOpList         (int id, w_Targs* args);  //();
extern "C" w_Targs* _GetUserHost       (int id, w_Targs* args);  //(char *nick);
extern "C" w_Targs* _GetUserIP         (int id, w_Targs* args);  //(char *nick);
extern "C" w_Targs* _GetUserCC         (int id, w_Targs* args);  //(char *nick);
extern "C" w_Targs* _Ban               (int id, w_Targs* args);  //(char *nick, long howlong, long bantype);
extern "C" w_Targs* _KickUser          (int id, w_Targs* args);  //(char *op, char *nick, char *data);
extern "C" w_Targs* _ParseCommand      (int id, w_Targs* args);  //(char *data);
extern "C" w_Targs* _SetConfig         (int id, w_Targs* args);  //(char *conf, char *var, char *val);
extern "C" w_Targs* _GetConfig         (int id, w_Targs* args);  //(char *conf, char *var);
extern "C" w_Targs* _AddRobot          (int id, w_Targs* args);  //(char *nick, long uclass, char *desc, char *speed, char *email, char *share);
extern "C" w_Targs* _DelRobot          (int id, w_Targs* args);  //(char *robot);
extern "C" w_Targs* _SQL               (int id, w_Targs* args);  //(char *query, long limit);
extern "C" w_Targs* _GetUsersCount     (int id, w_Targs* args);  //();
extern "C" w_Targs* _GetTotalShareSize (int id, w_Targs* args);  //();
extern "C" w_Targs* _UserRestrictions  (int id, w_Targs* args);  //(char *nick, char *gagtime, char *nopmtime, char *nosearchtime, char *noctmtime);
extern "C" w_Targs* _Topic             (int id, w_Targs* args);  //(char* topic);

#define w_ret0    cpiPython::lib_pack("l", (long)0)
#define w_ret1    cpiPython::lib_pack("l", (long)1)
#define w_retnone cpiPython::lib_pack("")

// logging levels:
// 0 - plugin critical errors, interpreter errors, bad call arguments
// 1 - callback / hook logging - only their status
// 2 - all function parameters and return values are printed
// 3 - debugging info is printed
#define log(...)                                        { printf( __VA_ARGS__ ); fflush(stdout); }
#define log1(...) { if (cpiPython::log_level > 0) { printf( __VA_ARGS__ ); fflush(stdout); }; }
#define log2(...) { if (cpiPython::log_level > 1) { printf( __VA_ARGS__ ); fflush(stdout); }; }
#define log3(...) { if (cpiPython::log_level > 2) { printf( __VA_ARGS__ ); fflush(stdout); }; }
#define log4(...) { if (cpiPython::log_level > 3) { printf( __VA_ARGS__ ); fflush(stdout); }; }
#define log5(...) { if (cpiPython::log_level > 4) { printf( __VA_ARGS__ ); fflush(stdout); }; }

#define dprintf(...) { printf("%s:%u: "__FILE__, __LINE__); printf( __VA_ARGS__ ); fflush(stdout); }

#endif
